
[![PyPI version](https://img.shields.io/pypi/v/imager200-python-sdk)](https://pypi.org/project/imager200-python-sdk/)

![client](https://www.imager200.io/assets/images/main-logo-compressed.png)


This package provides bindings for interacting with the imager200 API. It is auto-generated from the official open api specs: https://www.imager200.io/imager200.json

It is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 1.0.0
- Generator version: 7.8.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install imager200-python-sdk
```

Then import the package:
```python
import imager200_python_sdk
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import imager200_python_sdk
from imager200_python_sdk.rest import ApiException



configuration = imager200_python_sdk.Configuration(
    host = "https://api.imager200.io"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = "YOUR_API_KEY"

# Enter a context with an instance of the API client
with imager200_python_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = imager200_python_sdk.BlurhashApi(api_client)
    with open("/some/path/image.jpeg", "rb") as f:
        body = f.read() # bytearray | image binary data

    try:
        api_response = api_instance.blurhash_sync_post(body)
        with open("/some/path/result.jpeg", "wb") as result:
            result.write(api_response)
    except Exception as e:
        print("Exception when calling BlurhashApi->blurhash_sync_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.imager200.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BlendApi* | [**blend_async_post**](docs/BlendApi.md#blend_async_post) | **POST** /blend | 
*BlendApi* | [**blend_sync_post**](docs/BlendApi.md#blend_sync_post) | **POST** /blend/sync | 
*BlurApi* | [**blur_async_get**](docs/BlurApi.md#blur_async_get) | **GET** /blur | 
*BlurApi* | [**blur_async_post**](docs/BlurApi.md#blur_async_post) | **POST** /blur | 
*BlurApi* | [**blur_sync_get**](docs/BlurApi.md#blur_sync_get) | **GET** /blur/sync | 
*BlurApi* | [**blur_sync_post**](docs/BlurApi.md#blur_sync_post) | **POST** /blur/sync | 
*BlurhashApi* | [**blurhash_async_get**](docs/BlurhashApi.md#blurhash_async_get) | **GET** /blurhash | 
*BlurhashApi* | [**blurhash_async_post**](docs/BlurhashApi.md#blurhash_async_post) | **POST** /blurhash | 
*BlurhashApi* | [**blurhash_sync_get**](docs/BlurhashApi.md#blurhash_sync_get) | **GET** /blurhash/sync | 
*BlurhashApi* | [**blurhash_sync_post**](docs/BlurhashApi.md#blurhash_sync_post) | **POST** /blurhash/sync | 
*BlurpartialApi* | [**blurpartial_async_get**](docs/BlurpartialApi.md#blurpartial_async_get) | **GET** /blurpartial | 
*BlurpartialApi* | [**blurpartial_async_post**](docs/BlurpartialApi.md#blurpartial_async_post) | **POST** /blurpartial | 
*BlurpartialApi* | [**blurpartial_sync_get**](docs/BlurpartialApi.md#blurpartial_sync_get) | **GET** /blurpartial/sync | 
*BlurpartialApi* | [**blurpartial_sync_post**](docs/BlurpartialApi.md#blurpartial_sync_post) | **POST** /blurpartial/sync | 
*BrightnessApi* | [**brightness_async_get**](docs/BrightnessApi.md#brightness_async_get) | **GET** /brightness | 
*BrightnessApi* | [**brightness_async_post**](docs/BrightnessApi.md#brightness_async_post) | **POST** /brightness | 
*BrightnessApi* | [**brightness_sync_get**](docs/BrightnessApi.md#brightness_sync_get) | **GET** /brightness/sync | 
*BrightnessApi* | [**brightness_sync_post**](docs/BrightnessApi.md#brightness_sync_post) | **POST** /brightness/sync | 
*CompressApi* | [**compress_async_get**](docs/CompressApi.md#compress_async_get) | **GET** /compress | 
*CompressApi* | [**compress_async_post**](docs/CompressApi.md#compress_async_post) | **POST** /compress | 
*CompressApi* | [**compress_sync_get**](docs/CompressApi.md#compress_sync_get) | **GET** /compress/sync | 
*CompressApi* | [**compress_sync_post**](docs/CompressApi.md#compress_sync_post) | **POST** /compress/sync | 
*ConcatApi* | [**concat_async_post**](docs/ConcatApi.md#concat_async_post) | **POST** /concat | 
*ConcatApi* | [**concat_sync_post**](docs/ConcatApi.md#concat_sync_post) | **POST** /concat/sync | 
*ContrastApi* | [**contrast_async_get**](docs/ContrastApi.md#contrast_async_get) | **GET** /contrast | 
*ContrastApi* | [**contrast_async_post**](docs/ContrastApi.md#contrast_async_post) | **POST** /contrast | 
*ContrastApi* | [**contrast_sync_get**](docs/ContrastApi.md#contrast_sync_get) | **GET** /contrast/sync | 
*ContrastApi* | [**contrast_sync_post**](docs/ContrastApi.md#contrast_sync_post) | **POST** /contrast/sync | 
*ConvertApi* | [**convert_async_get**](docs/ConvertApi.md#convert_async_get) | **GET** /convert | 
*ConvertApi* | [**convert_async_post**](docs/ConvertApi.md#convert_async_post) | **POST** /convert | 
*ConvertApi* | [**convert_sync_get**](docs/ConvertApi.md#convert_sync_get) | **GET** /convert/sync | 
*ConvertApi* | [**convert_sync_post**](docs/ConvertApi.md#convert_sync_post) | **POST** /convert/sync | 
*CropApi* | [**crop_async_get**](docs/CropApi.md#crop_async_get) | **GET** /crop | 
*CropApi* | [**crop_async_post**](docs/CropApi.md#crop_async_post) | **POST** /crop | 
*CropApi* | [**crop_sync_get**](docs/CropApi.md#crop_sync_get) | **GET** /crop/sync | 
*CropApi* | [**crop_sync_post**](docs/CropApi.md#crop_sync_post) | **POST** /crop/sync | 
*EqualizeApi* | [**equalize_async_get**](docs/EqualizeApi.md#equalize_async_get) | **GET** /equalize | 
*EqualizeApi* | [**equalize_async_post**](docs/EqualizeApi.md#equalize_async_post) | **POST** /equalize | 
*EqualizeApi* | [**equalize_sync_get**](docs/EqualizeApi.md#equalize_sync_get) | **GET** /equalize/sync | 
*EqualizeApi* | [**equalize_sync_post**](docs/EqualizeApi.md#equalize_sync_post) | **POST** /equalize/sync | 
*GrayscaleApi* | [**grayscale_async_get**](docs/GrayscaleApi.md#grayscale_async_get) | **GET** /grayscale | 
*GrayscaleApi* | [**grayscale_async_post**](docs/GrayscaleApi.md#grayscale_async_post) | **POST** /grayscale | 
*GrayscaleApi* | [**grayscale_sync_get**](docs/GrayscaleApi.md#grayscale_sync_get) | **GET** /grayscale/sync | 
*GrayscaleApi* | [**grayscale_sync_post**](docs/GrayscaleApi.md#grayscale_sync_post) | **POST** /grayscale/sync | 
*ImageinfoApi* | [**imageinfo_sync_get**](docs/ImageinfoApi.md#imageinfo_sync_get) | **GET** /imageinfo | 
*ImageinfoApi* | [**imageinfo_sync_post**](docs/ImageinfoApi.md#imageinfo_sync_post) | **POST** /imageinfo | 
*PipelineApi* | [**pipeline_get**](docs/PipelineApi.md#pipeline_get) | **GET** /pipeline/{name} | 
*PipelineApi* | [**pipeline_get_status**](docs/PipelineApi.md#pipeline_get_status) | **GET** /pipeline/{execution_id}/status | 
*PipelineApi* | [**pipeline_post**](docs/PipelineApi.md#pipeline_post) | **POST** /pipeline/{name} | 
*ResizeApi* | [**resize_async_get**](docs/ResizeApi.md#resize_async_get) | **GET** /resize | 
*ResizeApi* | [**resize_async_post**](docs/ResizeApi.md#resize_async_post) | **POST** /resize | 
*ResizeApi* | [**resize_sync_get**](docs/ResizeApi.md#resize_sync_get) | **GET** /resize/sync | 
*ResizeApi* | [**resize_sync_post**](docs/ResizeApi.md#resize_sync_post) | **POST** /resize/sync | 
*RotateApi* | [**rotate_async_get**](docs/RotateApi.md#rotate_async_get) | **GET** /rotate | 
*RotateApi* | [**rotate_async_post**](docs/RotateApi.md#rotate_async_post) | **POST** /rotate | 
*RotateApi* | [**rotate_sync_get**](docs/RotateApi.md#rotate_sync_get) | **GET** /rotate/sync | 
*RotateApi* | [**rotate_sync_post**](docs/RotateApi.md#rotate_sync_post) | **POST** /rotate/sync | 
*TextApi* | [**text_async_get**](docs/TextApi.md#text_async_get) | **GET** /text | 
*TextApi* | [**text_async_post**](docs/TextApi.md#text_async_post) | **POST** /text | 
*TextApi* | [**text_sync_get**](docs/TextApi.md#text_sync_get) | **GET** /text/sync | 
*TextApi* | [**text_sync_post**](docs/TextApi.md#text_sync_post) | **POST** /text/sync | 


## Documentation For Models

 - [BlendRequest](docs/BlendRequest.md)
 - [ConcatRequest](docs/ConcatRequest.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ImageMetadata](docs/ImageMetadata.md)
 - [InfoResponse](docs/InfoResponse.md)
 - [PipelineExecutionResult](docs/PipelineExecutionResult.md)
 - [PipelineStatus](docs/PipelineStatus.md)
 - [SuccessResponse](docs/SuccessResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-Imager-Key
- **Location**: HTTP header


## Author

contact@imager200.io


